module Sbox
  (
   input logic [4:0]  x,
   output logic [4:0] Sx
   );
   
   //-- Signals ----
   logic              x0,x00,x1,x2,x22,x3,x4,x44,t0;
   logic [3:0]        t1;
   
   always_comb begin
      x0    = x[0] ^ x[4];
      x4    = x[4] ^ x[3];
      x2    = x[2] ^ x[1];
      
      t0    = x0 & ~(x4);
      t1[0] = x2 & ~(x[1]);
      
      x00   = x0 ^ t1[0];
      t1[1] = x4 & (~ x[3]);
      
      x22   = x2 ^ t1[1];
      t1[2] = x[1] & (~ x00);
      
      x44   = x4 ^ t1[2];
      t1[3] = x[3] & (~ x22);
      
      x1    = x[1] ^ t1[3];
      x3    = x[3] ^ t0;
      
      Sx[1] = x1 ^ x00;
      Sx[3] = x3 ^ x22;
      Sx[0] = x00 ^ x44;
      Sx[2] = ~ x22;
      Sx[4] = x44;
   end

endmodule 
