//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 05/15/2020 10:48:38 PM
// Design Name: 
// Module Name: SomeFunctions
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

package SomeFunctions;
    
  function integer conv_integer;
    input unsigned[1:0] A;

    case (A) 
      2'b00   : conv_integer = 0;
      2'b01   : conv_integer = 1;
      2'b10   : conv_integer = 2;
      2'b11   : conv_integer = 3;
    endcase // case (A)
  endfunction // conv_integer
   
  function [31:0] pad;
    input logic [31:0] I;
    input logic [2:0]  bytes;
    case (bytes)
      3'b000  : pad = 32'h80000000;
      3'b001  : pad = {I[31:24], 24'h800000};
      3'b010  : pad = {I[31:16], 16'h8000};
      3'b011  : pad = {I[31:8], 8'h80};
      default : pad = I;
    endcase // case (bytes)
  endfunction // pad

  function [31:0] trunc;
    input logic [31:0] bdi;
    input logic       bdi_eot;
    input logic [2:0] bdi_size;
    begin
      if (bdi_eot == 1'b0) begin
        trunc = bdi;
        end else begin
          case (bdi_size)
            3'b001  : trunc = {bdi[31:24], 24'h000000};
            3'b010  : trunc = {bdi[31:16], 16'h0000};
            3'b011  : trunc = {bdi[31:8], 8'h00};
            default : trunc = bdi;
          endcase // case (bdi_size)
        end
    end
  endfunction // trunc

  function [31:0] ext;
    input logic [127:0] O;
    input logic [1:0]   bytes;
    logic [31:0] MEM4X32 [3:0];

    MEM4X32 [0] = O[127:96];
    MEM4X32 [1] = O[95:64];
    MEM4X32 [2] = O[63:32];
    MEM4X32 [3] = O[31:0];

    //ext = MEM4X32[conv_integer(bytes)];
    ext = MEM4X32[bytes];
  endfunction // ext

endpackage // SomeFunctions
   
