module Sub_layer
  (
   input [63:0]        x0, x1, x2, x3, x4 ,
   output logic [63:0] Sx0, Sx1, Sx2, Sx3, Sx4
   );
   
   //-- Signals -------------------------------------------------
   logic [ 319:   0]   temp_in, temp_out; //-- Every column of current and updated state
   
   generate
      genvar           i;
      for (i =0; i<=63;i++) begin: Sl
         assign temp_in[(5*i + 4) : (5*i + 0)] = {x4[i],x3[i],x2[i],x1[i],x0[i]}; //-- Sbox input: x0,x1,x2,x3,x4
         Sbox Sb (
                  .x(  temp_in [5*i + 4 : 5*i + 0]),
                  .Sx( temp_out[5*i + 4 : 5*i + 0])
                  );
         assign Sx0[i] = temp_out[5*i + 0];
         assign Sx1[i] = temp_out[5*i + 1];
         assign Sx2[i] = temp_out[5*i + 2];
         assign Sx3[i] = temp_out[5*i + 3];
         assign Sx4[i] = temp_out[5*i + 4];
      end
    endgenerate
   
endmodule //architecture Behavioral
