// Copyright lowRISC contributors.
// Licensed under the Apache License, Version 2.0, see LICENSE for details.
// SPDX-License-Identifier: Apache-2.0
//
// Register Package auto-generated by `reggen` containing data structure

package rot_reg_pkg;

  // Param list
  parameter int PCR = 8;
  parameter int KEY = 4;

  ////////////////////////////
  // Typedefs for registers //
  ////////////////////////////
  typedef struct packed {
    logic [31:0] q;
  } rot_reg2hw_pcr_mreg_t;

  typedef struct packed {
    logic [31:0] q;
    logic        qe;
  } rot_reg2hw_key_mreg_t;

  typedef struct packed {
    struct packed {
      logic        q;
      logic        qe;
    } key_valid;
    struct packed {
      logic        q;
      logic        qe;
    } bdi_valid;
    struct packed {
      logic [3:0]  q;
      logic        qe;
    } bdi_type;
    struct packed {
      logic [2:0]  q;
      logic        qe;
    } bdi_size;
    struct packed {
      logic        q;
      logic        qe;
    } bdo_ready;
    struct packed {
      logic        q;
      logic        qe;
    } rst_sync;
    struct packed {
      logic        q;
      logic        qe;
    } hash_in;
    struct packed {
      logic        q;
      logic        qe;
    } decrypt_in;
    struct packed {
      logic        q;
      logic        qe;
    } pcr_update;
    struct packed {
      logic        q;
      logic        qe;
    } bdi_eot;
    struct packed {
      logic        q;
      logic        qe;
    } bdi_eoi;
    struct packed {
      logic [3:0]  q;
      logic        qe;
    } opcode;
    struct packed {
      logic        q;
      logic        qe;
    } msg_auth_ready;
  } rot_reg2hw_ctrl_reg_t;

  typedef struct packed {
    struct packed {
      logic        q;
      logic        qe;
    } key_ready;
    struct packed {
      logic        q;
      logic        qe;
    } bdi_ready;
    struct packed {
      logic        q;
      logic        qe;
    } bdo_valid;
    struct packed {
      logic        q;
      logic        qe;
    } end_of_block;
    struct packed {
      logic        q;
      logic        qe;
    } msg_auth;
    struct packed {
      logic        q;
      logic        qe;
    } msg_auth_valid;
  } rot_reg2hw_stat_reg_t;

  typedef struct packed {
    logic [31:0] q;
    logic        qe;
  } rot_reg2hw_bdi_reg_t;

  typedef struct packed {
    logic [31:0] q;
    logic        qe;
  } rot_reg2hw_bdo_reg_t;


  typedef struct packed {
    logic [31:0] d;
    logic        de;
  } rot_hw2reg_pcr_mreg_t;

  typedef struct packed {
    logic [31:0] d;
    logic        de;
  } rot_hw2reg_key_mreg_t;

  typedef struct packed {
    struct packed {
      logic        d;
      logic        de;
    } key_valid;
    struct packed {
      logic        d;
      logic        de;
    } bdi_valid;
    struct packed {
      logic [3:0]  d;
      logic        de;
    } bdi_type;
    struct packed {
      logic [2:0]  d;
      logic        de;
    } bdi_size;
    struct packed {
      logic        d;
      logic        de;
    } bdo_ready;
    struct packed {
      logic        d;
      logic        de;
    } rst_sync;
    struct packed {
      logic        d;
      logic        de;
    } hash_in;
    struct packed {
      logic        d;
      logic        de;
    } decrypt_in;
    struct packed {
      logic        d;
      logic        de;
    } pcr_update;
    struct packed {
      logic        d;
      logic        de;
    } bdi_eot;
    struct packed {
      logic        d;
      logic        de;
    } bdi_eoi;
    struct packed {
      logic [3:0]  d;
      logic        de;
    } opcode;
    struct packed {
      logic        d;
      logic        de;
    } msg_auth_ready;
  } rot_hw2reg_ctrl_reg_t;

  typedef struct packed {
    struct packed {
      logic        d;
      logic        de;
    } key_ready;
    struct packed {
      logic        d;
      logic        de;
    } bdi_ready;
    struct packed {
      logic        d;
      logic        de;
    } bdo_valid;
    struct packed {
      logic        d;
      logic        de;
    } end_of_block;
    struct packed {
      logic        d;
      logic        de;
    } msg_auth;
    struct packed {
      logic        d;
      logic        de;
    } msg_auth_valid;
  } rot_hw2reg_stat_reg_t;

  typedef struct packed {
    logic [31:0] d;
    logic        de;
  } rot_hw2reg_bdi_reg_t;

  typedef struct packed {
    logic [31:0] d;
    logic        de;
  } rot_hw2reg_bdo_reg_t;


  ///////////////////////////////////////
  // Register to internal design logic //
  ///////////////////////////////////////
  typedef struct packed {
    rot_reg2hw_pcr_mreg_t [7:0] pcr; // [499:244]
    rot_reg2hw_key_mreg_t [3:0] key; // [243:112]
    rot_reg2hw_ctrl_reg_t ctrl; // [111:78]
    rot_reg2hw_stat_reg_t stat; // [77:66]
    rot_reg2hw_bdi_reg_t bdi; // [65:33]
    rot_reg2hw_bdo_reg_t bdo; // [32:0]
  } rot_reg2hw_t;

  ///////////////////////////////////////
  // Internal design logic to register //
  ///////////////////////////////////////
  typedef struct packed {
    rot_hw2reg_pcr_mreg_t [7:0] pcr; // [507:244]
    rot_hw2reg_key_mreg_t [3:0] key; // [243:112]
    rot_hw2reg_ctrl_reg_t ctrl; // [111:78]
    rot_hw2reg_stat_reg_t stat; // [77:66]
    rot_hw2reg_bdi_reg_t bdi; // [65:33]
    rot_hw2reg_bdo_reg_t bdo; // [32:0]
  } rot_hw2reg_t;

  // Register Address
  parameter logic [5:0] ROT_PCR0_OFFSET = 6'h 0;
  parameter logic [5:0] ROT_PCR1_OFFSET = 6'h 4;
  parameter logic [5:0] ROT_PCR2_OFFSET = 6'h 8;
  parameter logic [5:0] ROT_PCR3_OFFSET = 6'h c;
  parameter logic [5:0] ROT_PCR4_OFFSET = 6'h 10;
  parameter logic [5:0] ROT_PCR5_OFFSET = 6'h 14;
  parameter logic [5:0] ROT_PCR6_OFFSET = 6'h 18;
  parameter logic [5:0] ROT_PCR7_OFFSET = 6'h 1c;
  parameter logic [5:0] ROT_KEY0_OFFSET = 6'h 20;
  parameter logic [5:0] ROT_KEY1_OFFSET = 6'h 24;
  parameter logic [5:0] ROT_KEY2_OFFSET = 6'h 28;
  parameter logic [5:0] ROT_KEY3_OFFSET = 6'h 2c;
  parameter logic [5:0] ROT_CTRL_OFFSET = 6'h 30;
  parameter logic [5:0] ROT_STAT_OFFSET = 6'h 34;
  parameter logic [5:0] ROT_BDI_OFFSET = 6'h 38;
  parameter logic [5:0] ROT_BDO_OFFSET = 6'h 3c;


  // Register Index
  typedef enum int {
    ROT_PCR0,
    ROT_PCR1,
    ROT_PCR2,
    ROT_PCR3,
    ROT_PCR4,
    ROT_PCR5,
    ROT_PCR6,
    ROT_PCR7,
    ROT_KEY0,
    ROT_KEY1,
    ROT_KEY2,
    ROT_KEY3,
    ROT_CTRL,
    ROT_STAT,
    ROT_BDI,
    ROT_BDO
  } rot_id_e;

  // Register width information to check illegal writes
  parameter logic [3:0] ROT_PERMIT [16] = '{
    4'b 1111, // index[ 0] ROT_PCR0
    4'b 1111, // index[ 1] ROT_PCR1
    4'b 1111, // index[ 2] ROT_PCR2
    4'b 1111, // index[ 3] ROT_PCR3
    4'b 1111, // index[ 4] ROT_PCR4
    4'b 1111, // index[ 5] ROT_PCR5
    4'b 1111, // index[ 6] ROT_PCR6
    4'b 1111, // index[ 7] ROT_PCR7
    4'b 1111, // index[ 8] ROT_KEY0
    4'b 1111, // index[ 9] ROT_KEY1
    4'b 1111, // index[10] ROT_KEY2
    4'b 1111, // index[11] ROT_KEY3
    4'b 0111, // index[12] ROT_CTRL
    4'b 0001, // index[13] ROT_STAT
    4'b 1111, // index[14] ROT_BDI
    4'b 1111  // index[15] ROT_BDO
  };
endpackage

